import { Overlay } from '@angular/cdk/overlay';
import { ComponentType } from '@angular/cdk/portal';
import { InjectionToken, Injector, OnDestroy, TemplateRef } from '@angular/core';
import { Location } from '@angular/common';
import { MatSlidePanelConfig } from './mat-slide-panel-config';
import { MatSlidePanelRef } from './mat-slide-panel-ref';
import * as i0 from "@angular/core";
export declare const MAT_SLIDE_PANEL_DEFAULT_OPTIONS: InjectionToken<MatSlidePanelConfig<any>>;
export declare class MatSlidePanel implements OnDestroy {
    private _overlay;
    private _injector;
    private _parentMatSlidePanel;
    private _location?;
    private _defaultOptions?;
    private _matSlidePanelAtThisLevel;
    /** Reference to the currently opened mat slide panel. */
    get _openedMatSlidePanelRef(): MatSlidePanelRef<any> | null;
    set _openedMatSlidePanelRef(value: MatSlidePanelRef<any> | null);
    constructor(_overlay: Overlay, _injector: Injector, _parentMatSlidePanel: MatSlidePanel, _location?: Location, _defaultOptions?: MatSlidePanelConfig);
    open<T, D = any, R = any>(component: ComponentType<T>, config?: MatSlidePanelConfig<D>): MatSlidePanelRef<T, R>;
    open<T, D = any, R = any>(template: TemplateRef<T>, config?: MatSlidePanelConfig<D>): MatSlidePanelRef<T, R>;
    /**
     * Dismisses the currently-visible mat slide panel.
     */
    dismiss(): void;
    ngOnDestroy(): void;
    /**
     * Attaches the mat slide panel container component to the overlay.
     */
    private _attachContainer;
    /**
     * Creates a new overlay and places it in the correct location.
     * @param config The user-specified mat slide panel config.
     */
    private _createOverlay;
    /**
     * Creates an injector to be used inside of a mat slide panel component.
     * @param config Config that was used to create the mat slide panel.
     * @param bottomSheetRef Reference to the mat slide panel.
     */
    private _createInjector;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatSlidePanel, [null, null, { optional: true; skipSelf: true; }, { optional: true; }, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MatSlidePanel>;
}
